#include "quadstar.h"

QuadStar::QuadStar(QWidget *parent) : QMainWindow(parent)
{
  ui.setupUi(this); // chargement de l'interface graphique
}


void QuadStar::on_pushButton_clicked()
{
  // recuperation du nom du dossier
  QString directory = QFileDialog::getExistingDirectory(this, "Dossier avec les fichiers CUE");
  if (!directory.isEmpty())
    ui.lineEdit->setText(directory);

}

void QuadStar::on_pushButton_2_clicked()
{
  // recuperation du nom du dossier
  QString fileNameType = "*.CUE"; // tous les fichiers
  QString directoryString = ui.lineEdit->text();
  QDir directory = QDir::QDir(directoryString); // le repertoire ou est le programme
  QStringList files;
  files = directory.entryList(QStringList(fileNameType), QDir::Files | QDir::NoSymLinks);

  QString fileName;
  int test = 0;
  for (int i = 0; i < files.size(); ++i) 
  {
    QString fileName = directory.absoluteFilePath(files[i]);
    ui.plainTextEdit->insertPlainText ( fileName); 
    test = modif_fichier(fileName);
    if(test == -1)
      ui.plainTextEdit->insertPlainText ( "==> Erreur !\n"); 
    else if(test == 0)
      ui.plainTextEdit->insertPlainText ( "==> Aucun changement !\n"); 
    if(test == 1)
      ui.plainTextEdit->insertPlainText ( "==> Fichier modifi !\n"); 

  }

}



int QuadStar::modif_fichier(QString fileName)
{
  // on verifie l'existence du fichier
  QFile file;
  file.setFileName(fileName);
  if( !file.exists() )
    return -1;      

  // creation des variables
  QString texte_complet = ""; 
  QString ligne1 = ""; 
  QString ligne2 = ""; 
  int modif = 0;
  int cpt=0;

  // lecture du fichier
  file.open(QIODevice::ReadOnly | QIODevice::Text );
  QTextStream in(&file);
  while (!in.atEnd()) 
  {
    if(cpt == 0)
    {
      cpt = 1;
      ligne1 = in.readLine(); 
    }
    else
    {
      ligne1 = ligne2; 
      ligne2 = in.readLine(); 

      if(ligne1.contains("INDEX 00") == TRUE && ligne2.contains("INDEX 01") == TRUE)
        modif = 1; 
      else
      {
        texte_complet = texte_complet + ligne1 + "\n";
      }

    }

  } // fin du while
  texte_complet = texte_complet + ligne2;

  file.close();

  // enregistrement du fichier s'il faut le modifier
  if(modif == 1)
  {
    file.open(QIODevice::WriteOnly | QIODevice::Text );
    QTextStream out(&file);
    out << texte_complet;    
    file.close();
  }

  return modif; // (0 ==> pas modif, 1 ==> texte modifie)

}
